﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Nido.Common.BackEnd;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;

namespace DemoTest.Bll.Models
{
    /// <summary>
    /// Created by MAS IT
    /// </summary>
    public class Address : BaseObject
    {
		public Address()
			// Change this parameter to change the DisplayName 
			// (this name is used in all system messages)
			// property of this object
			: base("Address") { }

		#region Public Properties
		[Key]
		[Required]
		[DisplayName("Address Id")]
		public int AddressId { get; set; }

		[Required]
		[DisplayName("Name")]
		public string Name { get; set; }

		[Required]
		[DisplayName("Description")]
		public string Description { get; set; }

		[InverseProperty("OfficeAddress")]
		[DisplayName("Office Address Students")]
		public ICollection<Student> OfficeAddressStudents { get; set; } 

		[InverseProperty("HomeAddress")]
		[DisplayName("Home Address Students")]
		public ICollection<Student> HomeAddressStudents { get; set; } 

		#endregion

		#region Not Mapped Properties

		/// <summary>
        /// Implement this to prevent or allow the object to be deleted through the base handler.
        /// You need to consider all dependant objects before allowing a object to be deleted.
        /// Therefore please implement this correctly/ accordingly.
        /// </summary>
		[NotMapped] 
		public override bool CanDelete
        {
            // TODO: Impletement this 
            // Example: return ((StudentCourses != null) && (StudentCourses.Count > 0)) ? false : true;
            get
            {
                if (_canDelete.HasValue)
                    return _canDelete.Value;
                else
                    return !(((OfficeAddressStudents != null) 
					 && (OfficeAddressStudents.Count > 0)) || ((HomeAddressStudents != null) 
					 && (HomeAddressStudents.Count > 0)));
            }
            set { _canDelete = value; }
        }
        private bool? _canDelete;

		[NotMapped]
		public override string DeleteError
		{
			get 
			{ 
				return "<b>" + ((OfficeAddressStudents != null) ? OfficeAddressStudents.Count.ToString() : "Indecisive # of") + "</b> OfficeAddressStudent(s) are using this 'Address'<br/>"
					 + "<b>" + ((HomeAddressStudents != null) ? HomeAddressStudents.Count.ToString() : "Indecisive # of") + "</b> HomeAddressStudent(s) are using this 'Address'<br/>"; 
			} 
		}
		
		[NotMapped]
		public override string DeleteErrorText
		{
			get 
			{ 
				return ((OfficeAddressStudents != null) ? OfficeAddressStudents.Count.ToString() : "Indecisive # of")
					 + " OfficeAddressStudent(s), " + ((HomeAddressStudents != null) ? HomeAddressStudents.Count.ToString() : "Indecisive # of")
					 + " HomeAddressStudent(s) are using this 'Address'";
			} 
		}

		/// <summary>
        /// This property set the value of the items of the combo box that created 
		/// deriving the BaseCombo. You may change this as needed.
        /// </summary>
        [NotMapped]
        public override string Value 
		{ get { return Convert.ToString(AddressId); } set { AddressId = Convert.ToInt32(value); } }

		/// <summary>
        /// This property set the display name of the items of the combo box that created 
		/// deriving the BaseCombo. You may modify or delete this as required.
        /// </summary>
        [NotMapped]
        public override string Text { get { return Name; } set { Name = value; } }
		
		#endregion

        public override string ToString()
        {
            return Name;
        }
    }
}
