﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Nido.Common.BackEnd;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;

namespace DemoTest.Bll.Models
{
    /// <summary>
    /// Created by MAS IT
    /// </summary>
    public class StudentCourse : BaseObject
    {
		public StudentCourse()
			// Change this parameter to change the DisplayName 
			// (this name is used in all system messages)
			// property of this object
			: base("Student Course") { }

		#region Public Properties
		[Key]
		[Required]
		[DisplayName("Student Course Id")]
		public int StudentCourseId { get; set; }

		[Required]
		[ForeignKey("Course")]
		[DisplayName("Course Id")]
		public int CourseId { get; set; }

		[DisplayName("Course")]
		public Course Course { get; set; } 

		[Required]
		[ForeignKey("Student")]
		[DisplayName("Student Id")]
		public int StudentId { get; set; }

		[DisplayName("Student")]
		public Student Student { get; set; } 

		#endregion

		#region Not Mapped Properties

		[NotMapped]
        public string CoursePopup
        {
            get
            {
                if (this.Course != null)
                    return this.CreatePopupText(this.Course.Text
                        , new TableCreator<Course>(this.Course)
                        .RemoveRecord(x => x.Value).RemoveRecord(x => x.Text)
                        .RemoveRecord(x => x.DeleteError).RemoveRecord(x => x.CanDelete)
                        .GetPopupTable());
                else
                    return "Indecisive record data!!";
            }
        }

		[NotMapped]
        public string StudentPopup
        {
            get
            {
                if (this.Student != null)
                    return this.CreatePopupText(this.Student.Text
                        , new TableCreator<Student>(this.Student)
                        .RemoveRecord(x => x.Value).RemoveRecord(x => x.Text)
                        .RemoveRecord(x => x.DeleteError).RemoveRecord(x => x.CanDelete)
                        .GetPopupTable());
                else
                    return "Indecisive record data!!";
            }
        }

		/// <summary>
        /// Implement this to prevent or allow the object to be deleted through the base handler.
        /// You need to consider all dependant objects before allowing a object to be deleted.
        /// Therefore please implement this correctly/ accordingly.
        /// </summary>
		[NotMapped] 
		public override bool CanDelete
        {
            // TODO: Impletement this 
            // Example: return ((StudentCourses != null) && (StudentCourses.Count > 0)) ? false : true;
            get
            {
                if (_canDelete.HasValue)
                    return _canDelete.Value;
                else
                    return true;
            }
            set { _canDelete = value; }
        }
        private bool? _canDelete;

		[NotMapped]
		public override string DeleteError
		{
			get 
			{ 
				return "Click to delete the record."; 
			} 
		}
		
		[NotMapped]
		public override string DeleteErrorText
		{
			get 
			{ 
				return "Click to delete the record.";
			} 
		}

		/// <summary>
        /// This property set the value of the items of the combo box that created 
		/// deriving the BaseCombo. You may change this as needed.
        /// </summary>
        [NotMapped]
        public override string Value 
		{ get { return Convert.ToString(StudentCourseId); } set { StudentCourseId = Convert.ToInt32(value); } }

		
		#endregion
    }
}
